
/**
 * Klasse Skytale.
 * 
 * @author claus albowski
 * @version okt'07
 */
public class Skytale
{
	private String original, chiffrat, dechiffrat;
	private int schluessel;

	/**
	 * Konstruktor fr Objekte der Klasse Caesar
	 */
	public Skytale()	{
		original = "HUNDKATZEVOGEL";
		chiffrat = "CHIFFRAT";
		dechiffrat = "DECHIFFRAT";
		schluessel = 3;
	}
	
	/**
	 * setzt den Schlssel.
	 */
	public void setzeSchluessel(int stabumfang){
	    schluessel = stabumfang;
	}
	
	/**
	 * setzt den Originaltext.
	 */
	public void setzeOriginal(String text){
	    original=text.toUpperCase();
	}
	
	/**
	 * setzt den Chiffrattext.
	 */
	public void setzeChiffrat(String text){
	    chiffrat=text.toUpperCase();
	}
	
	/**
	 * zeigt das Chiffrat an.
	 */
	public String gibChiffrat(){
	    return chiffrat;
	}

	/**
	 * zeigt das Dechiffrat an.
	 */
	public String gibDechiffrat(){
	    return dechiffrat;
	}
	
	// bersetzungsmethoden:
		
	/**
	 * chiffriert den Original-Text.
	 */
	public void chiffriere() {
	    StringBuffer[] temp = new StringBuffer[schluessel];
	    for (int i=0; i<schluessel; i++) temp[i] = new StringBuffer();
	    for (int i=0; i<original.length();i++)
	    temp[i%schluessel].append(original.charAt(i));
	    for (int i=1; i<schluessel; i++) temp[0].append(temp[i]);
	    chiffrat=temp[0].toString();
	   }
	   
	/**
	 * dechiffriert den Chiffrat-Text.
	 */
	public void dechiffriere() {
	    // Problem: Schlssellnge kein Teiler der Anzahl der Buchstaben
	    // Lsung:  anzahl / schluessel viele Buchstaben aus String holen und solange index<Rest einen mehr.
	    String[] temp = new String[schluessel];
	    int beginIndex = 0;
	    int endIndex = chiffrat.length()/schluessel;
	    for (int i=0; i<schluessel; i++) {
	        if (i<chiffrat.length()%schluessel) endIndex++;
	        temp[i]=chiffrat.substring(beginIndex, endIndex);
	        beginIndex=endIndex;
	        endIndex += chiffrat.length()/schluessel;
	    }
	    StringBuffer ergebnis = new StringBuffer();
	    for (int j=0; j<chiffrat.length()/schluessel; j++)
	    for (int i=0; i<schluessel; i++)
	    ergebnis.append(temp[i].charAt(j));
	    for (int i=0; i<chiffrat.length()%schluessel; i++)
	    ergebnis.append(temp[i].charAt(chiffrat.length()/schluessel));
	    dechiffrat=ergebnis.toString();
 	   }
}
